// Func.js
//========================   Описание   =====================================
// Скрипт-библитотека с различными Функциями, которые можно использовать в командах утилиты TCIMG
// Функции используются в команде funjs
//================   Примеры  использования   ===============================
// aends=<info=q1|encURI|cliptext> GLOBALAENDS<a>
// funjs=encURI|cliptext GLOBALFUNJS1<a>

// Автор:           Аверин Андрей
// Версия:          1.4 (09.05.2017 - 02.04.2018)
// Mail:            Averin-And@yandex.ru
// Help:            http://tcimg.dreamlair.net/TCIMG_ONLINE/html/html/com_funjs.htm
// Site:            http://tc-image.3dn.ru/forum/5-498-1
//========================================================================
	// AkelPad=new ActiveXObject("AkelPad.Document");
// Метод encodeURI заменяет все символы, исключая следующие, соответствующими им UTF-8 escape-последовательностями.
function encURI(Line){
	return encodeURI(Line)
}
// Декодирует строку кодированную методом encodeURI
function decURI(Line){
	return decodeURI(Line)
}
// длина строки
function Len(Line){
	return Line.length
}
// Преобразует массив JS для вывода в утилиту TCIMG
function ArrayJStoAutoit(arr){
  dicTmp=new ActiveXObject('Scripting.Dictionary');
  dicTmp.RemoveAll();
  for(var i=0;i<arr.length;i++){dicTmp.Add(i,arr[i]);}
  return dicTmp.Items();
}
//  ===========================================================================
// Xor кодирование/декодирование строки
function xorEncode(txt,pass){
  var ord=[]
  var buf=''
  for(z=1;z<=65535; z++){ord[fixedFromCharCode(z)]=z}
  for(j=z=0;z<txt.length; z++){
      buf+=fixedFromCharCode(ord[txt.substr(z,1)]^ord[pass.substr(j,1)])
      j=(j<pass.length)?j+1:0
  }
  return buf
}
// заплатка для String.fromCharCode()
function fixedFromCharCode(codePt){ 
  if(codePt>0xFFFF){ 
    codePt-=0x10000; 
    return String.fromCharCode(0xD800+(codePt>>10),0xDC00+(codePt&0x3FF)); 
  }else{ 
    return String.fromCharCode(codePt); 
  } 
}
//  ===========================================================================
// Base58 кодирование/декодирование строки
// кодирование строки
function Base58Encode(text) {
 return Base58.encode(toBytes(text));
}
// кодирование масcива
function Base58EncodeA(aArray) {
  var arrTXT=new VBArray(aArray).toArray()
  var Cnt = arrTXT.length;
  for(var i = 1; i < Cnt; ++i) {
    arrTXT[i] = Base58.encode(toBytes(arrTXT[i]));
  }
  return ArrayJStoAutoit(arrTXT);
}
// декодирование строки
function Base58Decode(text) {
 return fromBytes(Base58.decode(text.split("")));
}
// декодирование масcива
function Base58DecodeA(aArray) {
  var arrTXT=new VBArray(aArray).toArray()
  var Cnt = arrTXT.length;
  for(var i = 1; i < Cnt; ++i) {
    // arrTXT[i] = Base58.encode(toBytes(arrTXT[i]));
    arrTXT[i] = fromBytes(Base58.decode(arrTXT[i].split("")))
  }
  return ArrayJStoAutoit(arrTXT);
}

function toBytes(text) { // See https://www.browserling.com/js/tools-impl/base58-encode.js
   var bytes = [];
   for(var i = 0, l = text.length; i < l; ++i)
      bytes.push(text.charCodeAt(i));
   return bytes;
}
function fromBytes(bytes) {
   var out = [];
   for(var i = 0, l = bytes.length; i < l; ++i)
      out.push(String.fromCharCode(bytes[i]));
   return out.join("");
}

(function() {
  var ALPHABET, ALPHABET_MAP, Base58, i;

  //Base58 = (typeof module !== "undefined" && module !== null ? module.exports : void 0) || (window.Base58 = {});
  new Function("x", "Base58 = x;")((Base58 = {}));

  ALPHABET = "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";

  ALPHABET_MAP = {};

  i = 0;

  while (i < ALPHABET.length) {
    ALPHABET_MAP[ALPHABET.charAt(i)] = i;
    i++;
  }

  Base58.encode = function(buffer) {
    var carry, digits, j;
    if (buffer.length === 0) {
      return "";
    }
    i = void 0;
    j = void 0;
    digits = [0];
    i = 0;
    while (i < buffer.length) {
      j = 0;
      while (j < digits.length) {
        digits[j] <<= 8;
        j++;
      }
      digits[0] += buffer[i];
      carry = 0;
      j = 0;
      while (j < digits.length) {
        digits[j] += carry;
        carry = (digits[j] / 58) | 0;
        digits[j] %= 58;
        ++j;
      }
      while (carry) {
        digits.push(carry % 58);
        carry = (carry / 58) | 0;
      }
      i++;
    }
    i = 0;
    while (buffer[i] === 0 && i < buffer.length - 1) {
      digits.push(0);
      i++;
    }
    //return digits.reverse().map(function(digit) {
    //  return ALPHABET[digit];
    //}).join("");
    digits.reverse();
    for(var i = 0, l = digits.length; i < l; ++i)
       digits[i] = ALPHABET.charAt(digits[i]);
    return digits.join("");
  };

  Base58.decode = function(string) {
    var bytes, c, carry, j;
    if (string.length === 0) {
      return [];
    }
    i = void 0;
    j = void 0;
    bytes = [0];
    i = 0;
    while (i < string.length) {
      c = string[i];
      if (!(c in ALPHABET_MAP)) {
        throw "Base58.decode received unacceptable input. Character '" + c + "' is not in the Base58 alphabet.";
      }
      j = 0;
      while (j < bytes.length) {
        bytes[j] *= 58;
        j++;
      }
      bytes[0] += ALPHABET_MAP[c];
      carry = 0;
      j = 0;
      while (j < bytes.length) {
        bytes[j] += carry;
        carry = bytes[j] >> 8;
        bytes[j] &= 0xff;
        ++j;
      }
      while (carry) {
        bytes.push(carry & 0xff);
        carry >>= 8;
      }
      i++;
    }
    i = 0;
    while (string[i] === "1" && i < string.length - 1) {
      bytes.push(0);
      i++;
    }
    return bytes.reverse();
  };

}).call(this);

// Возвращает количество секунд прошедших с 1970 года
function Times() {
  return new Date().getTime()/1000;
}
//  ===========================================================================
// Google перевод данных масcива
function TranslateA(aArray, langSource, langTarget) {
  var arrTXT=new VBArray(aArray).toArray()
  var Cnt = arrTXT.length;
  for(var i = 1; i < Cnt; ++i) {
    arrTXT[i] = Translate(arrTXT[i], langSource, langTarget)
  }
  return ArrayJStoAutoit(arrTXT);
}
// Код соединён из кусков 2-х скриптов AkelPad: TranslateWithGoogleAPI.js (автор VladSh) и Translator.js (автор KDJ)
// Google перевод строки или многострочного теста
function Translate(Line, langSource, langTarget) {
  var req = createRequestObject();
  if (req) {
  	if (Line) {
  		var resultText;
  		idx = Line.search("[\r\n]");
  		Line = encodeURIComponent(Line);
  		Line = Line.replace(/^[ \t\r\n]+|[ \t\r\n]+$/, "");
  		var url = "http://translate.google.com/translate_a/single";
  		var params = "client=qlt&dt=bd&dt=t&sl=" + langSource + "&tl=" + langTarget + "&q=" + Line;
  		try {
  			req.open("POST", url, false);
  			req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  			req.onreadystatechange = function() {
  				if (req.readyState == 4) {
  					if (req.status == 200) {
  						try {
  							resultText = req.responseText;
  							eval("var resultObject = " + resultText);
  							if (idx == -1)
  							{
           resultText = resultObject[0][0][0];
           resultText = resultText.replace(/&/gm, '&');
           resultText = resultText.replace(/</gm, '<');
           resultText = resultText.replace(/>/gm, '>');
           resultText = resultText.replace(/"/gm, '"');
  							}
  						else
  						{
    						for (i = 0, resultText = ""; i < resultObject[0].length; ++i)
            resultText += resultObject[0][i][0];
    
          if (resultObject[1])
          {
            for (i = 0; i < resultObject[1].length; ++i)
            {
              resultText += "\n\n" + resultObject[1][i][0] + ":";
    
              for (k = 0; k < resultObject[1][i][2].length; ++k)
              {
                resultText += "\n" + (k + 1) + ". " + resultObject[1][i][2][k][0];
    
                if (resultObject[1][i][2][k][1])
                {
                  for (n = 0, resultText += " ("; n < resultObject[1][i][2][k][1].length; ++n)
                    resultText += resultObject[1][i][2][k][1][n] + ((n < resultObject[1][i][2][k][1].length - 1) ? ", " : ")");
                }
              }
            }
          }
  						}
  						}
  						catch (e) {
  							return "";
  						}
  					}
  					else {
  						return "";
  					}
  				}
  			};
  			req.send(params);
  		}
  		catch(e)
  			{
  			  return "";
  			}
  	}
	}
	resultText = resultText.replace(/(\r\n|\r|\n)/g, '\r\n');
	return resultText;
}

function createRequestObject() {
	if (typeof(XMLHttpRequest) === 'undefined') {
		XMLHttpRequest = function() {
			try { return new ActiveXObject("Msxml2.XMLHTTP"); }
			catch(e) {
				try { return new ActiveXObject("Microsoft.XMLHTTP"); }
				catch(e) {
					throw new Error("Your system does not support XMLHttpRequest.");
				}
			}
		};
	}
	return new XMLHttpRequest();
}


