' Func.vbs
'========================   Описание   =====================================
' Скрипт-библитотека с различными Функциями, которые можно использовать в командах утилиты TCIMG
'================   Примеры  использования   ===============================
' aends=<info=q0|GuidName> GLOBALAENDS<a>
' funvb=GuidName||ArrAllPath|%P%N GLOBALFUNVB1<a> GLOBALFUNVB2<a>
' aends=x??-3||##rndm<1|20> GLOBALAENDS<a> funvb=SortArrUpNum|$GLOBALAENDS|1 GLOBALFUNVB1<a>

' Автор:           Аверин Андрей
' Версия:          1.2 (09.05.2017 - 01.06.2017)
' Mail:            Averin-And@yandex.ru
' Help:            http://tcimg.dreamlair.net/TCIMG_ONLINE/html/html/com_funvb.htm
' Site:            http://tc-image.3dn.ru/forum/5-498-1
'========================================================================
' Функция создания уникального Guid имени
Function GuidName : NewGUID = CreateObject("Scriptlet.TypeLib").Guid : GuidName = Left(NewGUID, Len(NewGUID) - 2) End Function

' Возвращает полный путь для заданного относительного пути
Function GetPath(sPath) : GetPath = CreateObject("WScript.Shell").ExpandEnvironmentStrings(sPath) : End Function

' Функция получения массива всех родительских путей
' возвращается массив путей, в нулевой ячейке количество путей
Function ArrAllPath(sPath)
  sPath=GetPath(sPath)
  n = 1
  While a = 0
    If Len(sPath) < 4 Then Exit Function
    sPath = GetFF(sPath, 4)
    ReDim Preserve aArrray(n)
    If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    aArrray(n) = sPath : aArrray(0) = n : n = n + 1 : ArrAllPath = aArrray
  Wend
End Function

' Функция получения массива различных объектов файла/папки
Function GetArrF(sFile)
  On Error Resume Next
  Dim aArrray(23)
  aArrray(0) = 23
  For i = 1 To 23
    aArrray(i) = GetFF(sFile, i)
  Next
  GetArrF = aArrray
End Function

' Функция получения различных объектов файла и каталога/папки
Function GetFF(sFile, n)
  With CreateObject("Scripting.FileSystemObject")
      Select Case n
        Case 0 k = .GetParentFolderName(sFile) & "\" & .GetBaseName(sFile) & ".ini" ' конфиг файл
        Case 1 k = .GetExtensionName(sFile) ' расширение
        Case 2 k = .GetBaseName(sFile) ' имя без расширения
        Case 3 k = .GetFileName(sFile) ' имя с расширением
        Case 4 k = .GetParentFolderName(sFile) ' родительский путь
        Case 5 k = .GetParentFolderName(.GetParentFolderName(sFile)) ' дедушкин путь
        Case 6 k = .GetFile(sFile).ShortPath ' короткий путь к файлу в формате 8.3
        Case 7 k = .GetFile(sFile).ShortName ' короткое имя к файлу в формате 8.3
        Case 8 k = .GetFile(sFile).Drive.DriveLetter ' буква диска, на котором находится файл
        Case 9 k = .GetFile(sFile).DateCreated ' дата создания
        Case 10 k = .GetFile(sFile).DateLastAccessed ' дата последнего доступа
        Case 11 k = .GetFile(sFile).DateLastModified ' дата последней модификации
        Case 12 k = .GetFile(sFile).Size  ' размер
        Case 13 k = .GetFile(sFile).Type  ' тип файла

        Case 14 k = .GetFolder(sFile).ShortPath ' короткий путь к каталогу в формате 8.3
        Case 15 k = .GetFolder(sFile).ShortName ' короткое имя к каталогу в формате 8.3
        Case 16 k = .GetFolder(sFile).Drive.DriveLetter ' буква диска, на котором находится каталог
        Case 17 k = .GetFolder(sFile).DateCreated ' дата создания
        Case 18 k = .GetFolder(sFile).DateLastAccessed ' дата последнего доступа
        Case 19 k = .GetFolder(sFile).DateLastModified ' дата последней модификации
        Case 20 k = .GetFolder(sFile).Size  ' размер
        Case 21 k = .GetFolder(sFile).Type  ' тип каталога
        Case 22 k = .GetFolder(sFile).IsRootFolder   '  корневой каталог (True|False)
        Case 23 k = .GetParentFolderName(sFile) & "\" & .GetBaseName(sFile) ' путь с именем без расширения
      End Select
  End With : GetFF = k
End Function

' Функция сортировки элементов цифрового массива по возрастанию
 '  iStart - с какого элемента начать
Function SortArrUpNum(aArrray, iStart) k = Ubound(aArrray)
  If k > 0 Then
    For j = 0 To k - 1
      For i = iStart To k - 1 - j
        If CLng(aArrray(i)) > CLng(aArrray(i + 1)) Then SwapValue aArrray(i), aArrray(i + 1)
      Next
    Next : SortArrUpNum = aArrray
  End If
End Function

' Функция сортировки элементов цифрового массива по убыванию
 '  iStart - с какого элемента начать
Function SortArrDownNum(aArrray, iStart) k = Ubound(aArrray)
  If k > 0 Then
    For j = 0 To k - 1
      For i = iStart To k - 1 - j
        If CLng(aArrray(i)) < CLng(aArrray(i + 1)) Then SwapValue aArrray(i), aArrray(i + 1)
      Next
    Next : SortArrDownNum = aArrray
  End If
End Function

' Функция просмотра содержимого переменной или 1D массива
Function ViewValues(varArr, varTitle)
  If IsArray(varArr) Then
    iUb = Ubound(varArr)
    ListArr = "Массив :: Размер [" & iUb & "]" & vbNewLine
    For ii = 0 To iUb
      ListArr = ListArr & ii & " | " & varArr(ii) & vbNewLine
    Next
  Else
    ListArr = "Переменная" & vbNewLine & "<" & varArr & ">"
  End If : MsgBox ListArr , vbOKOnly , varTitle
End Function

' Процедура меняет местами  значения 2-х переданных переменных
Sub SwapValue(ByRef Value1, ByRef Value2)
  Temp = Value1 : Value1 = Value2 : Value2 = Temp
End Sub

' Фунция возвращает 2D массив с информацией о специальных папках системы
Function SpecFold
  On Error Resume Next
  Set List = CreateObject("Scripting.Dictionary")
  List.Add &H1d, "ALTSTARTUP"
  List.Add &H1a, "APPDATA"
  List.Add &Ha, "BITBUCKET"
  List.Add &H1e, "COMMONALTSTARTUP"
  List.Add &H23, "COMMONAPPDATA"
  List.Add &H19, "COMMONDESKTOPDIR"
  List.Add &H1f, "COMMONFAVORITES"
  List.Add &H17, "COMMONPROGRAMS"
  List.Add &H16, "COMMONSTARTMENU"
  List.Add &H18, "COMMONSTARTUP"
  List.Add &H3, "CONTROLS"
  List.Add &H21, "COOKIES"
  List.Add &H0, "DESKTOP"
  List.Add &H10, "DESKTOPDIRECTORY"
  List.Add &H11, "DRIVES"
  List.Add &H6, "FAVORITES"
  List.Add &H14, "FONTS"
  List.Add &H22, "HISTORY"
  List.Add &H20, "INTERNETCACHE"
  List.Add &H1c, "LOCALAPPDATA"
  List.Add &H27, "MYPICTURES"
  List.Add &H13, "NETHOOD"
  List.Add &H12, "NETWORK"
  List.Add &H5, "PERSONAL"
  List.Add &H4, "PRINTERS"
  List.Add &H1b, "PRINTHOOD"
  List.Add &H28, "PROFILE"
  List.Add &H26, "PROGRAMFILES"
  List.Add &H2, "PROGRAMS"
  List.Add &H8, "RECENT"
  List.Add &H9, "SENDTO"
  List.Add &Hb, "STARTMENU"
  List.Add &H7, "STARTUP"
  List.Add &H25, "SYSTEM"
  List.Add &H15, "TEMPLATES"
  List.Add &H24, "WINDOWS"
  List.Add &H30, "Администрирование"
  List.Add &H1, "Internet Explorer"
  List.Add &H31, "Сетевые подключения"
  
  Dim aArrray(2,39) : aArrray(0,0) = 39 : n = 1
  For Each Element In List
     With CreateObject("Shell.Application").NameSpace(Element)
       aArrray(0,n) = List.Item(Element)
       aArrray(1,n) = .Self.Path
       aArrray(2,n) = .Title
     End With
     If Err.Number <> 0 Then
       aArrray(1,n) = " Папка не найдена" : Err.Clear
     End If
     n = n + 1
  Next  
  SpecFold = aArrray
End Function

' Функция удаляет 1-ю ячейку массива если она равна размеру... (формат массива TCIMG)
Function Delete0Aray(aArrray)
  If Ubound(aArrray) = aArrray(0) Then
    Text = Join(aArrray, vbNewLine)
    Text = Mid(Text, Len(aArrray(0) & vbNewLine) + 1)
    aArrray =  Split(Text, vbNewLine)
  End If
  Delete0Aray = aArrray
End Function

' Функция собирает строки в колонки
 ' 1-й параметр Text - текст или массив
 ' 2-й параметр iMode - режим сборки: 0 - последовательный (по умолчанию), 1 - поочерёдный
 ' 3-й параметр: iColumn - по сколько столбцов (по умолчанию 2)
 ' 4-й параметр: min - количество символов-разделителей между колонками (по умолчанию 5)
 ' 5-й параметр: Sym - символ-разделитель (по умолчанию пробел)
Function LinesInCol(Text, iMode, iColumn, min, Sym)
  vb = vbNewLine : n = 0 : max=0 : Delim = "" : nDelim = 0 : min = CInt(min) : iMode = CInt(iMode) : iColumn = CInt(iColumn)
  If IsArray(Text) Then
    aArrray = Text : u = 1
    aArrray = Delete0Aray(aArrray)
  Else
    aArrray = Split(Text, vb) : u = 0
  End If
  x = Ubound(aArrray) : j = Int((x-1) / iColumn) : Count = x - j * iColumn + j : aArrray2 = CreateArray(Count)
  
  If iMode = 1 Then
    aArrray3 = CreateArray(iColumn)
    For i = 0 To x
      If (i Mod iColumn) = 0 And i <> 0 Then n = 0
      If i < iColumn Then
        Delim = ""
      Else
        Delim = vb
      End If
      aArrray3(n) = aArrray3(n) & Delim & aArrray(i)
      n = n + 1
    Next
    aArrray = Split(Join(aArrray3, vb), vb) : n = 0
  End If
  
  For i = 0 To x
    If (i Mod Count) = 0 And i <> 0 Then : nDelim = max + min : n = 0 : max=0 : End If
    If nDelim > 0 Then
      h = Len(aArrray(i - Count))
      Delim = StringCountLine(Sym, nDelim - h)
    Else
      Delim = ""
    End If
    aArrray2(n) = aArrray2(n) & Delim & aArrray(i)
    m = Len(aArrray(i))
    If m > max Then max = m
    n = n + 1
  Next
  
  If u = 1 Then
    LinesInCol = aArrray2
  Else
    LinesInCol = Join(aArrray2, vb)
  End If
End Function

' Функция создаёт массив с заданным количестом ячеек
Function CreateArray(Count) CreateArray = Split(Space(Count-1)) End Function

' Функция дублирования строки (быстрее цикла FOR ...)
Function StringCountLine(ssLine, jj)
  nn = Int(jj) : sfLine = "" : spLine = ssLine
  If Len(spLine) < 0 Or nn <= 0 Then
    StringCountLine = ""
    Exit Function
  End If
  Do While nn > 1
    If nn And 1 Then sfLine = sfLine & spLine
    spLine = spLine & spLine
    nn = Int(nn / 2)
  Loop
  StringCountLine = spLine & sfLine
End Function

' Функция поиска с помощью регулярных выражений
 ' rText - текст
 ' rRgEp - регулярное выражение,
 ' mm - 1 - Многострочно 0 - нет
 ' ic - 1 - Игнорировать регистр символов 0 - учитывать регистр символов
 ' gl - 1 - Проверять по всему тексту 0 - Проверять до первого соответствия
 ' param - возвращает:
 ' 1. Количество совпадений
 ' 2. Массив найденных подстрок
 ' 3. Массив всех индексов первого символа найденных подстрок в тексте
 ' 4. Массив всех длин найденных подстрок
 ' 5. 2-мерный массив (N,0) найденных подстрок, (N,1) индекс первого символа найденной подстроки в тексте, (N,2) длина найденной подстроки
 ' 6. В массив попадают подстроки относительно условий длины "6=30" (длина подстроки равна 30), "6>10" (длина больше 10), "6<5" (длина меньше 5) , "6<>17" (длина не равна 17) 
Function RegExpSearchPlus(rText, rRgEp, mm, ic, gl, param)
  Dim AR()
  With CreateObject("VBScript.RegExp")
    If mm = 1 Then .Multiline = True Else .Multiline = False End If
    If ic = 1 Then .IgnoreCase = True Else .IgnoreCase = False End If
    If gl = 1 Then .Global = True Else .Global = False End If
    If Left(param, 1) = 6 Then
      sCondition = Mid(param, 2)
      iCount = 0
      param = 6
    End If
    .Pattern = rRgEp : Set objMatches = .Execute(rText) : n = objMatches.Count
    If n > 0 And param > 1 Then
      If param = 5 Then ReDim Preserve AR(n-1, 2) Else ReDim Preserve AR(n - 1) End If
      For i = 0 To n - 1
        Set objMatch = objMatches.Item(i)
        Select Case param
          Case 2 AR(i) = objMatch.Value
          Case 3 AR(i) = objMatch.FirstIndex
          Case 4 AR(i) = objMatch.Length
          Case 5 AR(i, 0) = objMatch.Value : AR(i, 1) = objMatch.FirstIndex : AR(i, 2) = objMatch.Length
          Case 6 
            If Eval(objMatch.Length & sCondition) Then
              AR(iCount) = objMatch.Value
              iCount = iCount + 1
            End If
        End Select
      Next
      If param = 6 Then ReDim Preserve AR(iCount-1)
      RegExpSearchPlus = AR
    Else
      RegExpSearchPlus = n
    End If
  End With : QuitM
End Function

Sub QuitM : Set objMatch = Nothing : Set objMatches = Nothing : End Sub

